;************************************************
;LEKCJA  16	- UKAD TRANSMISJI RWNOLEGEJ 8255
;PRZYKAD 1	- TRYB 0 - PORT A i PORT B
;************************************************

;********** Ustawienie 8255 ***********
;PORT A -> wiata dla pieszych
;PA0 -> przejcie pionowo czerwone
;PA1 ->                   zielone
;PA2 -> przejcie poziomo czerwone
;PA3 ->                   zielone

;PORT B -> wiata dla samochodw
;PB3 -> przejazd pionowo czerwone
;PB4 ->                  te
;PB5 ->                  zielone
;PB0 -> przejazd poziomo czerwone
;PB1 ->                  te
;PB2 ->                  zielone

PA_M	EQU	0	;TRYB 0..2
PA_D	EQU	0	;OUT->0, IN->1
PCA_D	EQU	0	;OUT->0, IN->1
PB_M	EQU	0	;TRYB 0..1
PB_D	EQU	0	;OUT->0, IN->1
PCB_D	EQU	0	;OUT->0, IN->1

PA	EQU	PA_M*4+PA_D*2+PCA_D
PB	EQU	PB_M*4+PB_D*2+PCB_D
SET_8255	EQU	80H+PA*8+PB

;**************************************
	LJMP	START

;**************************************
	ORG	100H
START:
	MOV	R0,#CS55D		;inicjalizacja 8255
	MOV	A,#SET_8255
	MOVX	@R0,A

	MOV	R0,#CS55A		;zgaszenie wiate
	MOV	A,#0FFH			;-wpisanie jedynek
	MOVX	@R0,A			;na port A i B
	INC	R0
	MOVX	@R0,A

	MOV	R6,A		;stan LEDw
LOOP:

	MOV	R7,#6		;licznik - liczba diod
LOOP_ON:			;ptla wczania diod
	MOV	A,#5
	LCALL	DELAY_100MS

	MOV	A,R6
	CLR	C		;zapalenie kolejnej diody
	RLC	A
	MOV	R6,A
	MOVX	@R0,A
	DJNZ	R7,LOOP_ON	;powtrz zgodnie z R7

	MOV	R7,#6
LOOP_OFF:			;ptla wyczania diod
	MOV	A,#5
	LCALL	DELAY_100MS

	MOV	A,R6
	SETB	C		;zgaszenie kolejnej diody
	RLC	A
	MOV	R6,A
	MOVX	@R0,A
	DJNZ	R7,LOOP_OFF	;powtrz zgodnie z R7

	SJMP	LOOP
