;************************************************
;LEKCJA  18	- UKAD WATCHDOG
;PRZYKAD 1	- OBSUGA W PRZERWANIACH
;************************************************

;********* Ustawienie TIMERw *********
TMOD_SET	EQU	1	;Timer 0 - 16 bit

;**************************************

WD	EQU	P1.4	;Watchdog
LED	EQU	P1.7

	LJMP	START

;********* Przerwanie Timer 0 *********
	ORG	0BH
	CPL	WD		;obsuga ukadu Watchdog
	RETI

;**************************************
	ORG	100H
START:
	MOV	TMOD,#TMOD_SET
	SETB	EA		;wcz przerwanie
	SETB	ET0		;od Timera 0
	SETB	TR0		;wcz Timer 0
	CLR	WD		;uaktywnij Watchdog

LOOP:
	CLR	LED		;mruganie diod TEST
	MOV	A,#1
	LCALL	DELAY_100MS
	SETB	LED
	MOV	A,#1
	LCALL	DELAY_100MS

	LCALL	TEST_ENTER	;Enter = zakcenie
	JC	LOOP
				;zawieszenie programu
	SJMP	$		;w wyniku zakcenia
