;************************************************
;LEKCJA  18	- UKAD WATCHDOG
;PRZYKAD 5	- ROZPOZNANIE RDA SYGNAU RESET
;************************************************

WD	EQU	P1.4	;Watchdog
LED	EQU	P1.7

KOD	EQU	30H		;miejsce zapisania kodu
KOD1	EQU	'D'		;kolejne zanki kodu
KOD2	EQU	'S'
KOD3	EQU	'M'

	LJMP	START
	ORG	100H
START:

	MOV	A,#KOD1		;sprawdzenie obecnoci
	CJNE	A,KOD,FIRST	;kodu w pamici RAM
	MOV	A,#KOD2
	CJNE	A,KOD+1,FIRST
	MOV	A,#KOD3
	CJNE	A,KOD+2,FIRST

NEXT:				;kod jest - sygna RESET
	MOV	R2,#1		;z ukadu Watchdog

LOOP:				;mruganie diod TEST
	CLR	LED
	CLR	WD		;obsuga ukadu Watchdog
	MOV	A,R2
	LCALL	DELAY_100MS
LOOP1:
	SETB	LED
	SETB	WD		;obsuga ukadu Watchdog
	MOV	A,R2
	LCALL	DELAY_100MS

	LCALL	TEST_ENTER	;Enter = zakcenie
	JC	LOOP

	SJMP	$		;zawieszenie programu

FIRST:				;pierwsze uruchomienie
	MOV	R2,#3		;programu
	MOV	KOD,#KOD1	;wprowadzenie kodu do
	MOV	KOD+1,#KOD2	;pamici RAM
	MOV	KOD+2,#KOD3

	SJMP	LOOP
